using System.Collections;
using System.Collections.Generic;
using gaemstone.ECS.Utility;
using static flecs_hub.flecs;

namespace gaemstone.ECS;

public unsafe readonly struct EntityType
	: IReadOnlyList<IdRef>
{
	public World World { get; }
	public ecs_type_t* Handle { get; }

	public EntityType(World world, ecs_type_t* handle)
		{ World = world; Handle = handle; }

	public override string ToString()
		=> ecs_type_str(World, Handle).FlecsToStringAndFree()!;

	// IReadOnlyList implementation
	public int Count => Handle->count;
	public IdRef this[int index] => new(World, new(Handle->array[index]));
	public IEnumerator<IdRef> GetEnumerator() { for (var i = 0; i < Count; i++) yield return this[i]; }
	IEnumerator IEnumerable.GetEnumerator() => GetEnumerator();
}
